=== debian/changelog ===
belle-sip (1.6.3-5) unstable; urgency=medium

  * Team upload.
  * Cherry-Pick upstream fixes for crash with missing nonce at reg.
    Thanks to Bernhard Übelacker and Alf for testing (Closes: #921266)

 -- Bernhard Schmidt <berni@debian.org>  Wed, 17 Apr 2019 19:08:42 +0200

belle-sip (1.6.3-4) unstable; urgency=medium

  * Team upload.
  * Temporarily downgrade new errors in GCC-8 (Closes: #906452)

 -- Bernhard Schmidt <berni@debian.org>  Thu, 11 Oct 2018 00:00:59 +0200

belle-sip (1.6.3-3) unstable; urgency=medium

  * Team upload.
  * Remove Multi-Arch: same from libbellesip-dev package.
    Thanks to Francois Gouget <fgouget@free.fr> (Closes: #897324)
  * Use debhelper v11
  * Switch Vcs-URLs to salsa.d.o
  * Update Standards-Version to 4.1.4, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 01 May 2018 14:37:57 +0200

belle-sip (1.6.3-2) unstable; urgency=medium

  * Try to fix FTBFS on various architectures
    - Disable parallel building
    - Increase JAVA heap space

 -- Bernhard Schmidt <berni@debian.org>  Thu, 09 Nov 2017 23:03:30 +0100

belle-sip (1.6.3-1) unstable; urgency=medium

  * Team upload.

  [ Felix Lechner ]
  * Fix VCS URLs to point to packaging repository (Closes: #787170).

  [ Daniel Gnoutcheff ]
  * New upstream version 1.5.0
    - Updated symbols, fix-spelling-errors.patch
    - Now build-depends on libbctoolbox instead of polarssl
  * Switch to CMake for builds
  * Conservative upper bound for symbols/shlibs to control for API breakage
  * Point Vcs-* to git repository
  * Update copyright, descriptions

  [ Johannes Schauer ]
  * New upstream version 1.6.1
  * remove version restriction from libbctoolbox-dev
  * refreshed patch for 1.6.1
  * debian/docs: README => README.md
  * refresh debian/libbellesip0.symbols
  * add cmake-zlib.patch using "zlib" instead of "z" in pkg-config
    Requires.private
  * remove debian/libbellesip0.shlibs because of misleading version
    restriction
  * bump debhelper compatibility level to 10
  * debian/rules: Use hardening=+all
  * use CMAKE_SKIP_RPATH=ON to avoid rpath in libraries
  * run wrap-and-sort -abt
  * remove libbellesip-dbg in favour of automatically generated dbgsym package

  [ Dr. Tobias Quathamer ]
  * Use dh_strip --dbgsym-migration for the obsolete debug package
  * Use HTTPS URLs when possible
  * Update to Standards-Version 4.1.1
  * Minor update to debian/watch
  * New upstream version 1.6.3
  * Refresh symbols file for new upstream
  * Remove upstream signing key, as releases are not signed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 06 Nov 2017 14:09:32 +0100
