=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# FIXME Downgrade new errors from GCC-8
export DEB_CFLAGS_MAINT_APPEND = -Wno-error=format-truncation -Wno-error=cast-function-type

# On some arches (mips64el, s390x, alpha) antlr3 is extremely slow
# and throws a heap space OutOfMemory exception. Workaround by increasing
# heap space
export _JAVA_OPTIONS = -Xms512m -Xmx1024m

%:
	dh $@ --buildsystem=cmake --no-parallel

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON

override_dh_strip:
	dh_strip --dbgsym-migration='libbellesip-dbg (<< 1.6.3-1~)'
