=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/belle-sip-$1\.tar\.gz/ \
 https://github.com/BelledonneCommunications/belle-sip/tags .*/v?(\d\S*)\.tar\.gz
